# CONTRIBUTING

Contributions are always welcome. Contributions aren’t limit to contributing code directly! If you like to contribute
code that is of course welcome. [See below](#contributing-code) for more details. None code contributions can have
various forms from testing over improving the documentation or input for feature ideas.

If you like to help on testing you can look through issues with the
label [`help wanted`](https://github.com/skadi-cloud/gist/issues?q=is%3Aissue+is%3Aopen+label%3A%22help+wanted%22). All
of these issues allow for none code contributions. Either in the form of testing a something or by describing your
environment that you like to use the project in.

For feature ideas you can [open an issue](https://github.com/skadi-cloud/gist/issues/new) in the project describing your
idea or open a [discussion](https://github.com/skadi-cloud/gist/discussions/).

For documentation, you can add it to the readme file in the repository and create a pull request with you addition.

# Contributing Code

Feel free to contribute code. You should be able to clone the repository and compile the code with gradle and/or
IntelliJ out of the box. The [readme](/README.md) is a good starting point to understand the content of the repository
and how contributions are structured best to make integrating them easy.

Feel free to choose issues that have
the [`good first issue`](https://github.com/skadi-cloud/gist/issues?q=is%3Aissue+is%3Aopen+label%3A%22good+first+issue%22)
label if you are looking for something to contribute. For questions you can use
the [Github discussion](https://github.com/skadi-cloud/gist/discussions) feature or open an issue with the
label `question`. The discussion feature is generally preferred over issues for questions.

For contributing you code please open a [pull request](https://github.com/skadi-cloud/gist/pulls) in the project. If you
plan to do feature development or bug fixes that require larger changes to the codebase feel it is a good idea to open a
draft pull request early on, so we can discuss your design together.

